//+------------------------------------------------------------------+
//|                                            Points_ZZ_Reverse.mq4 |
//+------------------------------------------------------------------+
#property copyright "figar0"
#property link      "figaro@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_width1 2

//---- indicator parameters
extern int Pips  = 300;
extern int Peaks = 5;
//---- indicator buffers

double zz[];
double zzH[];
double zzL[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexArrow(2,174);
   SetIndexArrow(1,174);
//---- indicator buffers mapping
   SetIndexBuffer(0,zz);
   SetIndexBuffer(1,zzH);
   SetIndexBuffer(2,zzL);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
//---- indicator short name
   IndicatorShortName("Point_ZZ_Reverse("+Pips+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
{
}
//+------------------------------------------------------------------+
int start()
{
   int i, LHB=0, LLB=0, Direction=0, Counter=0;
   double LH, LL;
   LH=High[0]; LL=Low[0]; LHB=0; LLB=0; zz[0]=0; zzH[0]=0; zzL[0]=0;
   for( i=1; i<Bars; i++)
   {
     zz[i]=0;
     if (High[i]>LH) 
     {
       if (Direction==1) {LH=High[i]; LHB=i; LL=High[i]; LLB=i; continue;} //  
       LH=High[i];
       LHB=i;
     } 
     if (Low[i]<LL) 
     {
       if (Direction==-1) {LL=Low[i]; LLB=i; LH=Low[i]; LHB=i; continue;}//  
       LL=Low[i];
       LLB=i;
     }   
     if ((LH-LL)/Point> Pips && LHB!=LLB) //  
     {
         if (LHB<LLB && Direction!=-1)
         {
           if (Counter>=Peaks) break;
           Counter++;
           zz[LHB]=LH;
           zzH[LHB]=LH;
           Direction=-1;
           LH=Low[i];
           LL=Low[i];
           LHB=i;
           LLB=i;
           continue;                     
         }
         if (LHB>LLB && Direction!=1)
         {
           if (Counter>=Peaks) break;
           Counter++;
           zz[LLB]=LL;
           zzL[LLB]=LL;
           Direction=1;  
           LH=High[i];
           LL=High[i];
           LHB=i;
           LLB=i;
           continue;                 
         }
     }
  }

     
  return(0);
}
//+------------------------------------------------------------------+